unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  brushColor, penColor, curColor: TColor;
  map: array of array of TPoint;
  figure: array of TPoint;

implementation

{$R *.lfm}

{ TForm1 }

Procedure putPixel(x, y: Integer; ln: Integer = 0; fill: boolean = false);
var len: Integer;
begin
  Form1.PaintBox1.Canvas.Pixels[x,y]:=curColor;
  if (fill=true) then begin
    len:=Length(map[x]);
    SetLength(map[x],len+1);
    map[x,len]:=Point(y,ln);
  end;
end;

procedure lineSort(index:Integer);
var
  i,j,k,l,A,B,C,D:Integer;
  fl: real;
  deep: array of real;
  arr: array [0..510] of array of Integer;
  x,y,z: TPoint;
begin
  for i:=510 downto 0 do begin
      setlength(arr[i],0);
  end;
  for i:=Length(map[index])-1 downto 0 do begin
      j:=Length(arr[map[index][i].x]);
      setlength(arr[map[index][i].x],j+1);
      arr[map[index][i].x][j]:=map[index][i].y;
  end;
  l:=length(figure);
  for k:=510 downto 0 do begin
      if (length(arr[k])>1) then begin
        setLength(deep,length(arr[k]));
        for i:=length(arr[k])-1 downto 0 do begin
            if (l>0) then begin
              A:=figure[arr[k,i]-1].y-figure[arr[k,i] mod l].y;
              B:=figure[arr[k,i] mod l].x-figure[arr[k,i]-1].x;
              C:=-A*figure[arr[k,i]-1].x-B*figure[arr[k,i]-1].y;
              if (B<>0) then begin
                deep[i]:=(A*index+C+0.0)/(-B+0.0);
              end else begin
                deep[i]:=k;
              end;
            end else begin
              deep[i]:=k;
            end;
        end;
        for i:=length(arr[k])-1 downto 1 do begin
            for j:=i-1 downto 0 do begin
                if (deep[i]>deep[j]) then begin
                  D:=arr[k,i];
                  arr[k,i]:=arr[k,j];
                  arr[k,j]:=D;
                  fl:=deep[i];
                  deep[i]:=deep[j];
                  deep[j]:=fl;
                end else if (deep[i]=deep[j]) and (l>0) then begin
                  if (arr[k,i]<arr[k,j]) and ((arr[k,j]<>length(figure)) or (arr[k,i]<>1)) then begin
                     x:=figure[arr[k,i]-1];
                     y:=figure[arr[k,j] mod l];
                     z:=figure[arr[k,i]];
                  end else begin
                     x:=figure[arr[k,i] mod l];
                     y:=figure[arr[k,j]-1];
                     z:=figure[arr[k,j] mod l];
                  end;
                  A:=z.y-x.y;
                  B:=abs(x.x-z.x);
                  C:=z.y-y.y;
                  D:=abs(y.x-z.x);
                  if ((D=0) and (C>0)) or ((A<=0) and (C>0)) or ((A<0) and (C=0)) or ((A>0) and (C>0) and (B*C>A*D)) or ((A<0) and (C<0) and (B*C>A*D)) then begin
                     D:=arr[k,i];
                     arr[k,i]:=arr[k,j];
                     arr[k,j]:=D;
                  end;
                end;
            end;
        end;
      end;
  end;
  i:=0;j:=0;
  for k:=0 to 510 do begin
      if (length(arr[k])>0) then begin
        for i:=length(arr[k])-1 downto 0 do begin
           map[index,j]:=Point(k,arr[k][i]);
           inc(j);
        end;
      end;
  end;
end;

procedure circleNorm(xmin, xmax: Integer);
var
  i,j,x,y: Integer;
begin
  setlength(figure,0);
  for i:=xmin to xmax do begin
    lineSort(i);
    j:=length(map[i]);
    x:=map[i,j div 2].x;
    y:=map[i,(j div 2)-1].x;
    setLength(map[i],2);
    map[i,0]:=Point(y,5);
    map[i,1]:=Point(x,6);
  end;
end;

procedure deletePoint(x,y: Integer; ln: Integer = 0; val: Integer = 0);
var i:integer;
begin
  for i:=length(map[x])-1 downto 0 do begin
    if (map[x,i].x=y) then begin
      if ((ln>0) and (map[x,i].y=ln)) or (ln=0) then begin
        map[x,i].y:=val;
        exit;
      end;
    end;
  end;
end;

procedure deleteLine(x,ln: Integer);
var i:Integer;
begin
  if (ln=0) then ln:=length(figure);
  for i:=length(map[x])-1 downto 0 do begin
    if (map[x,i].y=ln) then begin
      map[x,i].y:=0;
    end;
  end;
end;

procedure figureNorm(xmin, xmax: Integer);
var
  i,j,x,y,l: Integer;
  upPoint,leftPoint: boolean;
begin
  for i:=xmin to xmax do begin
    lineSort(i);
  end;
  l:=length(figure);
  for i:=l-1 downto 0 do begin
    x:=figure[(i+1) mod l].x;
    y:=figure[(i-1+l) mod l].x;
    x:=x-figure[i].x;
    y:=y-figure[i].x;
    if ((x>0) and (y>0)) or ((x<0) and (y<0)) then begin
      //both on one side
    end else if ((x<0) and (y>0)) or ((x>0) and (y<0)) then begin
      //on different sides, remove any
      deleteLine(figure[i].x,i);
    end else if (x=0) and (y=0) then begin
      //on one line - no such situation!!!
    end else begin
      //one is vertical
      upPoint:=false;
      leftPoint:=false;
      if (x=0) then begin
          j:=i+1;
          if (figure[(i+1) mod l].y<figure[i].y) then begin
            upPoint:=true;
          end;
          if (y<0) then begin
            leftPoint:=true;
          end;
          deleteLine(figure[i].x,i);
      end else begin
          j:=i;
          if (j=0) then j:=l;
          if (figure[(i-1+l) mod l].y<figure[i].y) then begin
            upPoint:=true;
          end;
          if (x<0) then begin
            leftPoint:=true;
          end;
          deleteLine(figure[i].x,i+1);
      end;
      if (upPoint=true) then begin
        if (leftPoint=true) then begin
           //5 and 9
           deletePoint(figure[i].x,figure[i].y,j,-4);
        end else begin
           //4 and 8
           deletePoint(figure[i].x,figure[i].y,j,-3);
        end;
      end else begin
        if (leftPoint=true) then begin
           //3 and 7
           deletePoint(figure[i].x,figure[i].y,j,-1);
        end else begin
           //2 and 6
           deletePoint(figure[i].x,figure[i].y,j,-2);
        end;
      end;
    end;
  end;

end;

procedure runFill(xMin,xMax:Integer);
var
 i,j: Integer;
 draw: byte;
 vert: Integer;
 lines: array of Integer;
 prev: Integer;
 lowest: Integer;
 vertDraw: byte;
 adding: boolean;
begin
 for i:=xmin to xmax do begin
     draw:=0;
     vert:=0;
     lowest:=0;
     vertDraw:=0;
     setlength(lines,0);
     j:=length(map[i])-1;
     prev:=form1.PaintBox1.Canvas.Height-1;
     adding:=false;
     while (j>=0) do begin
         if (prev>map[i,j].x) then begin
           if ((length(lines)-lowest) mod 2=1) then begin
             draw:=1-draw;
           end;
           lowest:=length(lines);
           if (draw=1) and (vert=0) then begin
             while (prev>map[i,j].x) do begin
                 putpixel(i,prev);
                 dec(prev);
             end;
           end else begin
             prev:=map[i,j].x;
           end;
         end;
         while (j>=0) and (map[i,j].x=prev) do begin
             if (map[i,j].y<0) then begin
               if (vert=0) then begin
                 vertDraw:=draw;
                 vert:=map[i,j].y;
               end else begin
                   if (map[i,j].y+vert=-5) then begin
                     draw:=vertDraw;
                   end else begin
                     draw:=1-vertDraw;
                   end;
                   vertDraw:=0;
                   vert:=0;
                   lowest:=length(lines);
               end;
             end else if (map[i,j].y>0) then begin
               if (adding=false) then begin
                  while (lowest<length(lines)) and (map[i,j].y<>lines[lowest]) do begin
                    inc(lowest);
                    draw:=1-draw;
                 end;
               end;
               if (lowest=length(lines)) or (adding=true) then begin
                 adding:=true;
                 setlength(lines,length(lines)+1);
                 lines[length(lines)-1]:=map[i,j].y;
               end;
             end;
             dec(j);
         end;
         adding:=false;
         dec(prev);
     end;
     setlength(map[i],0);
 end;
end;

Procedure line(x1, y1, x2, y2: Integer; ln: Integer = 0; fill: boolean = false);
var dx, dy, d, d1, d2, x, y, stp: Integer;
begin
  curColor:=penColor;
  dx := x2 - x1;
  dy := y2 - y1;
  if ((abs(dx) > abs(dy)) and (x2 < x1))
    or ((abs(dx) <= abs(dy)) and (y2 < y1)) then begin
      x := x1;
      x1 := x2;
      x2 := x;
      y := y1;
      y1 := y2;
      y2 := y;
  end;
  dx := x2 - x1;
  dy := y2 - y1;
  stp := 1;
  putPixel(x1,y1,ln,fill);
  if (abs(dx) > abs(dy)) then begin
    if (dy < 0) then begin
      stp := -1;
      dy := -dy;
    end;
    d := (dy * 2) - dx;
    d1 := dy * 2;
    d2 := (dy - dx) * 2;
    y := y1;
    for x := x1 + 1 to x2 do begin
      if (d > 0) then begin
        y := y + stp;
        d := d + d2;
      end else
        d := d + d1;
      putPixel(x,y,ln,fill);
    end;
  end else begin
    if (dx < 0) then begin
      stp := -1;
      dx := -dx;
    end;
    d := (dx * 2) - dy;
    d1 := dx * 2;
    d2 := (dx - dy) * 2;
    x := x1;
    for y := y1 + 1 to y2 do begin
      if (d > 0) then begin
        x := x + stp;
        d := d + d2;
      end else
        d:=d+d1;
      putPixel(x,y,ln,fill);
    end;
  end;
end;

procedure circle(x,y,r: Integer; fill: boolean = false);
var x1,y1,d1,d2: Integer;
begin
 x1:=0;
 y1:=r;
 curColor:=penColor;
 while (x1<=round(r/sqrt(2))) do begin
   putPixel(x+x1,y+y1,1,fill);
   putPixel(x+x1,y-y1,2,fill);
   putPixel(x-x1,y+y1,3,fill);
   putPixel(x-x1,y-y1,4,fill);
   putPixel(x+y1,y+x1,1,fill);
   putPixel(x+y1,y-x1,2,fill);
   putPixel(x-y1,y+x1,3,fill);
   putPixel(x-y1,y-x1,4,fill);
   x1:=x1+1;
   d1:=abs(r*r-x1*x1-y1*y1);
   d2:=abs(r*r-x1*x1-(y1-1)*(y1-1));
   if(d1>d2) then y1:=y1-1;
 end;
 curColor:=penColor;
end;

procedure fillCircle(x,y,r: Integer);
begin
  circle(x,y,r,true);
  curColor:=brushColor;
  circleNorm(x-r,x+r);
  runFill(x-r,x+r);
  curColor:=penColor;
end;

procedure drawFigure(arr: array of TPoint; fill: boolean = false);
var i: Integer;
begin
  for i:=1 to length(arr)-1 do begin
    line(arr[i-1].x,arr[i-1].y,arr[i].x,arr[i].y,i,fill);
  end;
  line(arr[i].x,arr[i].y,arr[0].x,arr[0].y,i+1,fill);
end;

procedure fillFigure(arr: array of TPoint);
var xmin,xmax,i: Integer;
begin
  drawFigure(arr,true);
  curColor:=brushColor;
  setlength(figure,length(arr));
     xmin:=arr[0].x;xmax:=arr[0].x;
     figure[0]:=arr[0];
     for i:=length(arr)-1 downto 1 do begin
       if (xmin>arr[i].x) then xmin:=arr[i].x;
       if (xmax<arr[i].x) then xmax:=arr[i].x;
       figure[i]:=arr[i];
     end;
     figureNorm(xmin,xmax);
     runFill(xmin,xmax);
     curColor:=penColor;
end;

procedure TForm1.Button1Click(Sender: TObject);
var arr: array of TPoint;
begin
 SetLength(map,510);
 brushColor:=RGBtoColor(107,147,214); //земля
 penColor:=RGBtoColor(107,147,214);
 fillcircle(293,308,137);
 setlength(arr,22); //земля ЮА
 brushColor:=RGBtoColor(159,193,100);
 penColor:=RGBtoColor(159,193,100);
 arr[0]:=Point(316,440);
 arr[1]:=Point(322,429);
 arr[2]:=Point(322,412);
 arr[3]:=Point(340,378);
 arr[4]:=Point(340,372);
 arr[5]:=Point(333,366);
 arr[6]:=Point(327,372);
 arr[7]:=Point(311,358);
 arr[8]:=Point(311,338);
 arr[9]:=Point(300,326);
 arr[10]:=Point(288,321);
 arr[11]:=Point(282,310);
 arr[12]:=Point(276,315);
 arr[13]:=Point(270,327);
 arr[14]:=Point(277,344);
 arr[15]:=Point(277,377);
 arr[16]:=Point(270,390);
 arr[17]:=Point(277,422);
 arr[18]:=Point(282,422);
 arr[19]:=Point(288,418);
 arr[20]:=Point(300,429);
 arr[21]:=Point(311,433);
 fillfigure(arr);
 setlength(arr,16); //земля СА
 arr[0]:=Point(282,298);
 arr[1]:=Point(293,282);
 arr[2]:=Point(293,264);
 arr[3]:=Point(282,256);
 arr[4]:=Point(282,240);
 arr[5]:=Point(294,207);
 arr[6]:=Point(305,197);
 arr[7]:=Point(287,178);
 arr[8]:=Point(279,175);
 arr[9]:=Point(245,185);
 arr[10]:=Point(223,195);
 arr[11]:=Point(199,211);
 arr[12]:=Point(197,230);
 arr[13]:=Point(225,247);
 arr[14]:=Point(230,270);
 arr[15]:=Point(265,275);
 fillfigure(arr);
 setlength(arr,12); //земля Е
 arr[0]:=Point(390,259);
 arr[1]:=Point(402,259);
 arr[2]:=Point(413,265);
 arr[3]:=Point(420,265);
 arr[4]:=Point(419,258);
 arr[5]:=Point(415,248);
 arr[6]:=Point(410,240);
 arr[7]:=Point(408,235);
 arr[8]:=Point(390,215);
 arr[9]:=Point(390,224);
 arr[10]:=Point(384,230);
 arr[11]:=Point(384,248);
 fillfigure(arr);
end;

end.

